<?php
/*
Minimalist memberlist backup tool for an OekakiPoteto-based oekaki

http://www.NineChime.com/Wacintosh.htm
Version 1.1.1 - Last modified 11/10/2012

Supported Oekakis:
	OekakiPoteto:  v4.x - v5.1.5aa
	PotatoPoteto:  all known versions (discontinued)
	Wacintaki:     all to v1.5.13
	Wax Poteto:    all to v5.8.9
*/


// CONFIG	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=
{
	// Backup file location.  Make this unique!
	$backup_file = './dback/members_bak.txt';

	// Password to run this script
	$password = 'changeme';

	// I/O
	$this_file = 'mbackup.php';
}



// ADVANCED CONFIG	=	=	=	=	=	=	=	=	=	=	=	=	=
//
// Custom import only!  Don't change unless you know what you're doing!
{
	$debug = FALSE;

	// Trim auto-increment from database
	$shift_auto_increment = TRUE;

	// Convert PotatoPoteto "userAccess" to OekakiPoteto "usrflags"
	$pp_to_op = FALSE;

	// Use database field remapper
	$db_custom = FALSE;
	$db_format = array (
		'birthdate'=>'age',
		'userAccess'=>'usrflags'
	);
}



// INIT	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=
//
// Leave this alone unless you're a programmer
//
// MySQL reflection
$db_155_layer = FALSE;
$ref = 'mysql';
if (file_exists ('db_layer.php')) {
	$db_155_layer = TRUE;
	$ref = 'db';
}
$db_query       = $ref.'_query';
$db_num_rows    = $ref.'_num_rows';
$db_result      = $ref.'_result';
$db_fetch_row   = $ref.'_fetch_row';
$db_fetch_array = $ref.'_fetch_array';
$db_error       = $ref.'_error';
$db_close       = $ref.'_close';



// BEGIN	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=

print_header();

// Lazy?
if ($password == 'changeme') {
	p_line('Set a new password, first!');
	print_footer();
	exit;
} elseif ($backup_file == './dback/members_bak.txt') {
	p_line('Set a new backup directory.  It should be hidden or kept secret from the public.');
	print_footer();
	exit;
}

// Authenticate
if ($_POST['power'] != $password) {
	ask_pass();
	print_footer();
	exit;
}

// No input yet
if (empty ($_POST['mode'])) {
	ask_mode();
}

// Confirm for catastrophic recovery
if ($_POST['op'] == 'confirm') {
	confirm_recovery();
	print_footer();
	exit ();
}

// Backup
if ($_POST['mode'] == 'backup') {
	// Start backup.  Get database
	if ($db_155_layer) {
		require ('db_layer.php');
		db_open();
	} else {
		require ('dbconn.php');
	}
	if (!$dbconn) {
		p_line('Cannot connect to database: '.$db_error_func());
		print_footer();
		exit ();
	}
	if (!isset ($db_mem)) {
		$db_mem = $OekakiPoteto_MemberPrefix;
	}


	// First, verify that the database has something in it.
	// We don't want people accidently destroying their only
	// good backup file!
	$result = $db_query_func ("SELECT usrname FROM {$db_mem}oekaki");
	if ($db_num_rows_func ($result) < 1) {
		$db_close_func ();
		p_line ('No data was found in the member database!');
		print_footer();
		exit ();
	}


	$result = $db_query_func ("SHOW COLUMNS FROM {$db_mem}oekaki");
	if ($result) {
		// Get the columns and count
		$num_fields = $db_num_rows_func ($result);
		$fields = array ();
		for ($i = 0; $i < $num_fields; $i++) {
			// I have no clue why SHOW FIELDS is an alias for SHOW COLUMNS.
			// So, we'll have to pull down all the columns.
			// mysql_list_fields() does the same thing, but is deprecated and unreliable.
			$row = $db_fetch_row_func ($result);
			$fields[] = $row[0];
		}

		// Open backup file
		$fp = fopen ($backup_file, 'w');
		if ($fp) {
			// Write field names
			fwrite ($fp, (make_list($fields, "\t")."\n"));


			// OK, time to torture the database
			$result2 = $db_query_func ("SELECT * FROM {$db_mem}oekaki");
			$row_count = $db_num_rows_func ($result2);

			for ($i = 0; $i < $row_count; $i++) {
				$row = $db_fetch_row_func ($result2);

				$line = make_list($row, "\t");

				// Convert \n (and \r\n)!
				// "PHP_EOL" does NOT work
				$line = str_replace ("\r\n", '\n', $line);
				$line = str_replace ("\n", '\n', $line);

				fwrite ($fp, $line."\n");
			}
			fclose ($fp);

			p_line ('Backup completed successfully!  Don\'t forget to put the backup file in a safe place where the public won\'t find it.');
		} else {
			p_line ('Error: cannot open backup file for writing.');
		}
	} else {
		p_line ('SQL error: cannot open memberlist table.');
	}

	$db_close_func ($dbconn);
}

// Restore
if ($_POST['mode'] == 'restore') {
	$op = $_POST['op'];

	if ($db_155_layer) {
		require ('dblayer.php');
		db_open();
	} else {
		require ('dbconn.php');
	}
	if (!$dbconn) {
		p_line('Cannot connect to database: '.$db_error_func());
		print_footer();
		exit ();
	}
	if (!isset ($db_mem)) {
		$db_mem = $OekakiPoteto_MemberPrefix;
	}

	$fp = fopen ($backup_file, 'r');
	if ($fp) {
		$line = trim (fgets ($fp, 4096));
		$fields = explode ("\t", $line);

		// Shift off the auto-increment if required
		if ($shift_auto_increment) array_shift ($fields);

		$num_fields = count ($fields);


		// DB cleanup, if needed
		if ($op == 'recovery' && !$debug) {
			// Flush the database.
			p_line ('Flushing database...');

			$result = $db_query_func ("SELECT ID FROM {$db_mem}oekaki");
			$del_rows = $db_num_rows_func ($result);

			$del_names = array ();
			for ($i = 0; $i < $del_rows; $i++) {
				$del_names[] = $db_result_func ($result, $i);
			}
			for ($i = 0; $i < $del_rows; $i++) {
				$result = $db_query_func ("DELETE FROM {$db_mem}oekaki WHERE ID='{$del_names[$i]}'");
			}
			unset ($del_rows);
			unset ($del_names);

			if (!$result) {
				fclose ($fp);
				p_line('Error:  cannot flush memberlist.  Try again, or use a tool like phpMyAdmin to clear all entries.  Do <b>NOT</b> drop the table!');
				p_line('Reason:  '.$db_error_func() );
				$db_close_func ($dbconn);
				exit ();
			}
		}

		// Handle remapping for custom import
		if ($db_custom) {
			$i = 0;
			foreach ($fields as $item) {
				if (isset ($db_format[$item])) {
					$fields[$i] = $db_format[$item];
				}
				$i++;
			}
		}

		// Get names in db (for update or freshen)
		$names_in_db = array ();
		$result = $db_query_func ("SELECT usrname FROM {$db_mem}oekaki");
		$num_rows = $db_num_rows_func ($result);
		for ($i = 0; $i < $num_rows; $i++) {
			$names_in_db[] = $db_result_func ($result, $i);
		}

		// PotatoPoteto to OP hack (step 1/2)
		$pos = FALSE;
		if ($pp_to_op) {
			// It's REALLY stupid that in_array() doesn't return the postition!
			// Even worse, array_search() can return wierd results if it doesn't find what it's looking for.
			$i = 0;
			foreach ($fields as $field) {
				if ($field == 'usrflags') {
					$pos = $i;
				}
				$i++;
			}
		}


		// Ready to import
		$insert_count = 0;
		$update_count = 0;
		$db_backup = array (); // Backed-up fields
		while (!feof ($fp)) {
			$line = trim (fgets ($fp, 4096));

			// Convert \n!
			$line = str_replace ('\n', "\n", $line);

			if (!empty ($line)) {
				$db_backup = explode ("\t", $line);
				if ($shift_auto_increment) array_shift ($db_backup);

				// PotatoPoteto to OP hack (step 1/2)
				if ($pos !== FALSE) {
					if ($db_backup[$pos] == 9) {
						$db_backup[$pos] = 'OSAGDMIU';
					} else {
						$db_backup[$pos] = 'GDM';
					}
				}

				// Make name/value pairs for SQL
				$db_insert = array (); // 'SET' lines for SQL
				for ($i = 0; $i < $num_fields; $i++) {
					$db_insert[] = "{$fields[$i]}='{$db_backup[$i]}'";
				}

				// Prepare SQL
				if ($op == 'recovery') {
					// If recovery
					$sql = "INSERT INTO {$db_mem}oekaki SET ";
					$sql .= make_list ($db_insert, ', ');
					$insert_count++;

					if ($debug) {
						p_line($sql);
					} else {
						$db_query_func ($sql);
					}
				} elseif ($op == 'append') {
					// If append
					if (!in_array ($db_backup[0], $names_in_db)) {
						$sql = "INSERT INTO {$db_mem}oekaki SET ";
						$sql .= make_list ($db_insert, ', ');
						$insert_count++;

						if ($debug) {
							p_line($sql);
						} else {
							$db_query_func ($sql);
						}
					}
				} elseif ($op == 'freshen') {
					// If freshen
					if (in_array ($db_backup[0], $names_in_db)) {
						$sql = "UPDATE {$db_mem}oekaki SET ";
						$sql .= make_list ($db_insert, ', ');
						$sql .= " WHERE usrname='{$db_backup[0]}'";
						$update_count++;

						if ($debug) {
							p_line($sql);
						} else {
							$db_query_func ($sql);
						}
					}
				}
			}
		}
		fclose ($fp);

		p_line ('Finished updating database!');
		web_line ('Total accounts added:  '.$insert_count);
		web_line ('Total accounts updated:  '.$update_count);
	} else {
		p_line ('Error: cannot open backup file for reading.');
	}

	$db_close_func ($dbconn);
}

print_footer();
exit;



// FUNCTIONS	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=	=

function print_header() {
	echo "<html>\n<body>\n";
}

function print_footer() {
	echo "</body>\n</html>\n";
}

function p_line($in) {
	echo '<p>'.$in.'</p>'."\n";
}

function web_line($in) {
	echo $in.'<br />'."\n";
}

function make_list($array, $sep) {
	$list = '';
	$items = count($array);

	if ($items == 1) {
		return $array[0];
	} elseif ($items > 0) {
		for ($i = 0; $i < ($items - 1); $i++) {
			$list .= $array[$i].$sep;
		}
		$list .= $array[$i];

		return $list;
	}

	return;
}

function ask_pass() {
echo <<<EOF
	<p>Please enter your password.  If you haven't set one yet, open this file in a text editor and make one!</p>
	<form action="{$this_file}" method="post">
		Password: <input type="password" name="power" value="" /><br />
		<br />
		<input type="submit" name="submit" value="Next" />
	</form>

EOF;

}

function ask_mode() {
echo <<<EOF
	<h2>Memberlist backup for OekakiPoteto (and most mods)</h2>
	<p>
		This script will backup a memberlist stored in the MySQL table &ldquo;op_oekaki&rdquo;, where &ldquo;op_&rdquo; is your member database prefix.  It will also restore or append the memberlist with passwords intact should your memberlist become corrupt.
	</p>
	<p>
		<strong>WARNING</strong>:  Keep the backup file in a safe, hidden place!  Leaving it in the OP folder can be a security risk!  It is recommended that you change the &ldquo;\$backup_file&rdquo; variable in this script to automatically put the backup file into a secret folder, such as &ldquo;\$backup_file = './secretname/member_bak.txt'&rdquo;</strong>
	</p>
	<p>
		<strong>NOTE</strong>:  If you're moving your board to another server, make sure your password encryption key is identical to the one you used on your old server.
	</p>

	<hr />
	<br />

	<fieldset>
		<form action="{$this_file}" method="post">
			<h3>BACKUP:</h3>
			<input type="hidden" name="power" value="{$_POST['power']}" />
			<input type="hidden" name="mode" value="backup" />
			<input type="submit" name="submit" value="Backup" />
		</form>
	</fieldset>
	<br />

	<fieldset>
		<form action="{$this_file}" method="post">
			<h3>RESTORE:</h3>
			<input type="hidden" name="power" value="{$_POST['power']}" />
			<input type="hidden" name="mode" value="restore" />

			<input type="radio" name="op" value="confirm" /> Restore the memberlist, replacing <strong>all</strong> exising user names.  For catastrophic recovery only.<br />
			<input type="radio" name="op" value="append" /> Append the memberlist.  New accounts will be added, but existing members will not be modified.<br />
			<input type="radio" name="op" value="freshen" /> Freshen the memberlist.  Existing accounts will be updated, but none will be removed, and no new ones will be added.<br />
			<br />
			<input type="submit" name="submit" value="Restore" />
		</form>
	</fieldset>

EOF;

}

function confirm_recovery() {
echo <<<EOF
	<h2>Catastrophic recovery</h2>
	<p>
		This will flush any bad records from your memberlist and restore all member profiles from your backup file.  Do this only if needed and your backup file is up to date, or profiles will be lost!
	</p>

	<hr />
	<br />

	<fieldset>
		<form action="{$this_file}" method="post">
			<h3>RESTORE:</h3>
			<input type="hidden" name="power" value="{$_POST['power']}" />
			<input type="hidden" name="mode" value="restore" />
			<input type="hidden" name="op" value="recovery" />

			<input type="submit" name="submit" value="Perform recovery" />
		</form>
	</fieldset>

EOF;

}

?>